#!/usr/bin/env Rscript

#' Excludes nothing


# sink("Rout.txt")

netids = 'test'
corpus <- "fullset.encoded.csv"
args = commandArgs(trailingOnly=TRUE)
if(length(args)>0) {
	corpus <- args[1]
	path <- args[2]
	netids <- args[-2]
}

source("fct.encode.R")

require(dplyr, quietly=TRUE, warn.conflicts=FALSE)
require(tidyr, quietly=TRUE, warn.conflicts=FALSE)
require(stringr, quietly=TRUE, warn.conflicts=FALSE)
options(dplyr.width = Inf)




for(netid in netids){
	fullset <- tbl_df(read.csv(corpus, header=T, encoding="UTF-8", stringsAsFactors=FALSE))
	
	print(netid)
	unlink(str_c(path,"/",netid,".*"))

	# #' Exclude one token per verb of a certain full-paradigm set
	# completes <- fullset %>% filter(!Testitem & fullPN) %>% select(Lemma) %>% distinct()
	# dropped <- sample(c("sg1","sg2","sg3","pe4","pl2"), nrow(completes), replace=TRUE)
	# novelTokens <- data.frame(completes, dropPN=dropped)
	# novelTokens$dropPN <- as.character(novelTokens$dropPN)
	# fullset <- left_join(fullset, novelTokens) %>% mutate(dropPN = ifelse(is.na(dropPN), "nodrop", dropPN)) %>% mutate(trained=ifelse(PN==dropPN, FALSE, TRUE))
	fullset$trained <- TRUE


#' Subsets
	trainset <- filter(fullset, trained)
	testset <- filter(fullset, trained & Testitem)
	novelset <- testset



	#' Add untrained items to testset
	# testset <- filter(fullset, Testitem | !trained)


	#'
	#' Write example files
	#' 
	trainset <- arrange(trainset, Subclass, Lemma, PN)
	testset <- arrange(testset, Subclass, Lemma, PN)
	novelset <- arrange(novelset, Subclass, Lemma, PN)

	write.csv(trainset, file=str_c(path,'/',netid,'.trainset','.csv'), fileEncoding='UTF-8', row.names=FALSE)
	write.csv(testset, file=str_c(path,'/',netid,'.testset','.csv'), fileEncoding='UTF-8', row.names=FALSE)
	write.csv(novelset, file=str_c(path,'/',netid,'.novelset','.csv'), fileEncoding='UTF-8', row.names=FALSE)

	writeExamples(trainset, str_c(path,'/',netid,'.trainset','.ex'))
	writeExamples(testset, str_c(path,'/',netid,'.testset','.ex'))
	writeExamples(novelset, str_c(path,'/',netid,'.novelset','.ex'))

}

# sink()